# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Compute::Mgmt::V2018_04_01
  module Models
    #
    # Describes each OS upgrade on the Virtual Machine Scale Set.
    #
    class UpgradeOperationHistoricalStatusInfoProperties

      include MsRestAzure

      # @return [UpgradeOperationHistoryStatus] Information about the overall
      # status of the upgrade operation.
      attr_accessor :running_status

      # @return [RollingUpgradeProgressInfo] Counts of the VMs in each state.
      attr_accessor :progress

      # @return [ApiError] Error Details for this upgrade if there are any.
      attr_accessor :error

      # @return [UpgradeOperationInvoker] Invoker of the Upgrade Operation.
      # Possible values include: 'Unknown', 'User', 'Platform'
      attr_accessor :started_by

      # @return [ImageReference] Image Reference details
      attr_accessor :target_image_reference

      # @return [RollbackStatusInfo] Information about OS rollback if performed
      attr_accessor :rollback_info


      #
      # Mapper for UpgradeOperationHistoricalStatusInfoProperties class as Ruby
      # Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'UpgradeOperationHistoricalStatusInfoProperties',
          type: {
            name: 'Composite',
            class_name: 'UpgradeOperationHistoricalStatusInfoProperties',
            model_properties: {
              running_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'runningStatus',
                type: {
                  name: 'Composite',
                  class_name: 'UpgradeOperationHistoryStatus'
                }
              },
              progress: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'progress',
                type: {
                  name: 'Composite',
                  class_name: 'RollingUpgradeProgressInfo'
                }
              },
              error: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'error',
                type: {
                  name: 'Composite',
                  class_name: 'ApiError'
                }
              },
              started_by: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'startedBy',
                type: {
                  name: 'Enum',
                  module: 'UpgradeOperationInvoker'
                }
              },
              target_image_reference: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'targetImageReference',
                type: {
                  name: 'Composite',
                  class_name: 'ImageReference'
                }
              },
              rollback_info: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'rollbackInfo',
                type: {
                  name: 'Composite',
                  class_name: 'RollbackStatusInfo'
                }
              }
            }
          }
        }
      end
    end
  end
end
