# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Compute::Mgmt::V2019_03_01
  module Models
    #
    # Specifies information about the gallery Image Version that you want to
    # create or update.
    #
    class GalleryImageVersion < Resource

      include MsRestAzure

      # @return [GalleryImageVersionPublishingProfile]
      attr_accessor :publishing_profile

      # @return [Enum] The current state of the gallery Image Version. The
      # provisioning state, which only appears in the response. Possible values
      # include: 'Creating', 'Updating', 'Failed', 'Succeeded', 'Deleting',
      # 'Migrating'
      attr_accessor :provisioning_state

      # @return [GalleryImageVersionStorageProfile]
      attr_accessor :storage_profile

      # @return [ReplicationStatus]
      attr_accessor :replication_status


      #
      # Mapper for GalleryImageVersion class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'GalleryImageVersion',
          type: {
            name: 'Composite',
            class_name: 'GalleryImageVersion',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              publishing_profile: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.publishingProfile',
                type: {
                  name: 'Composite',
                  class_name: 'GalleryImageVersionPublishingProfile'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              storage_profile: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.storageProfile',
                type: {
                  name: 'Composite',
                  class_name: 'GalleryImageVersionStorageProfile'
                }
              },
              replication_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.replicationStatus',
                type: {
                  name: 'Composite',
                  class_name: 'ReplicationStatus'
                }
              }
            }
          }
        }
      end
    end
  end
end
