# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Compute::Mgmt::V2020_12_01
  module Models
    #
    # Input for InstallPatches on a Linux VM, as directly received by the API
    #
    class LinuxParameters

      include MsRestAzure

      # @return [Array<VMGuestPatchClassificationLinux>] The update
      # classifications to select when installing patches for Linux.
      attr_accessor :classifications_to_include

      # @return [Array<String>] packages to include in the patch operation.
      # Format: packageName_packageVersion
      attr_accessor :package_name_masks_to_include

      # @return [Array<String>] packages to exclude in the patch operation.
      # Format: packageName_packageVersion
      attr_accessor :package_name_masks_to_exclude

      # @return [String] This is used as a maintenance run identifier for Auto
      # VM Guest Patching in Linux.
      attr_accessor :maintenance_run_id


      #
      # Mapper for LinuxParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'LinuxParameters',
          type: {
            name: 'Composite',
            class_name: 'LinuxParameters',
            model_properties: {
              classifications_to_include: {
                client_side_validation: true,
                required: false,
                serialized_name: 'classificationsToInclude',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'VMGuestPatchClassificationLinuxElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              package_name_masks_to_include: {
                client_side_validation: true,
                required: false,
                serialized_name: 'packageNameMasksToInclude',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              package_name_masks_to_exclude: {
                client_side_validation: true,
                required: false,
                serialized_name: 'packageNameMasksToExclude',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              maintenance_run_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maintenanceRunId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
