# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Compute::Mgmt::V2020_12_01
  module Models
    #
    # Input for InstallPatches as directly received by the API
    #
    class VirtualMachineInstallPatchesParameters

      include MsRestAzure

      # @return [String] Specifies the maximum amount of time that the
      # operation will run. It must be an ISO 8601-compliant duration string
      # such as PT4H (4 hours)
      attr_accessor :maximum_duration

      # @return [VMGuestPatchRebootSetting] Defines when it is acceptable to
      # reboot a VM during a software update operation. Possible values
      # include: 'IfRequired', 'Never', 'Always'
      attr_accessor :reboot_setting

      # @return [WindowsParameters] Input for InstallPatches on a Windows VM,
      # as directly received by the API
      attr_accessor :windows_parameters

      # @return [LinuxParameters] Input for InstallPatches on a Linux VM, as
      # directly received by the API
      attr_accessor :linux_parameters


      #
      # Mapper for VirtualMachineInstallPatchesParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'VirtualMachineInstallPatchesParameters',
          type: {
            name: 'Composite',
            class_name: 'VirtualMachineInstallPatchesParameters',
            model_properties: {
              maximum_duration: {
                client_side_validation: true,
                required: true,
                serialized_name: 'maximumDuration',
                type: {
                  name: 'String'
                }
              },
              reboot_setting: {
                client_side_validation: true,
                required: true,
                serialized_name: 'rebootSetting',
                type: {
                  name: 'String'
                }
              },
              windows_parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'windowsParameters',
                type: {
                  name: 'Composite',
                  class_name: 'WindowsParameters'
                }
              },
              linux_parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'linuxParameters',
                type: {
                  name: 'Composite',
                  class_name: 'LinuxParameters'
                }
              }
            }
          }
        }
      end
    end
  end
end
