# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Monitor::Mgmt::V2015_05_01
  #
  # Composite Swagger for Application Insights Management Client
  #
  class AnalyticsItems
    include MsRestAzure

    #
    # Creates and initializes a new instance of the AnalyticsItems class.
    # @param client service class for accessing basic functionality.
    #
    def initialize(client)
      @client = client
    end

    # @return [ApplicationInsightsManagementClient] reference to the ApplicationInsightsManagementClient
    attr_reader :client

    #
    # Gets a list of Analytics Items defined within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param scope [ItemScope] Enum indicating if this item definition is owned by
    # a specific user or is shared between all users with access to the Application
    # Insights component. Possible values include: 'shared', 'user'
    # @param type [ItemTypeParameter] Enum indicating the type of the Analytics
    # item. Possible values include: 'none', 'query', 'function', 'folder',
    # 'recent'
    # @param include_content [Boolean] Flag indicating whether or not to return the
    # content of each applicable item. If false, only return the item information.
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [Array] operation results.
    #
    def list(resource_group_name, resource_name, scope_path, scope:nil, type:nil, include_content:nil, custom_headers:nil)
      response = list_async(resource_group_name, resource_name, scope_path, scope:scope, type:type, include_content:include_content, custom_headers:custom_headers).value!
      response.body unless response.nil?
    end

    #
    # Gets a list of Analytics Items defined within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param scope [ItemScope] Enum indicating if this item definition is owned by
    # a specific user or is shared between all users with access to the Application
    # Insights component. Possible values include: 'shared', 'user'
    # @param type [ItemTypeParameter] Enum indicating the type of the Analytics
    # item. Possible values include: 'none', 'query', 'function', 'folder',
    # 'recent'
    # @param include_content [Boolean] Flag indicating whether or not to return the
    # content of each applicable item. If false, only return the item information.
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def list_with_http_info(resource_group_name, resource_name, scope_path, scope:nil, type:nil, include_content:nil, custom_headers:nil)
      list_async(resource_group_name, resource_name, scope_path, scope:scope, type:type, include_content:include_content, custom_headers:custom_headers).value!
    end

    #
    # Gets a list of Analytics Items defined within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param scope [ItemScope] Enum indicating if this item definition is owned by
    # a specific user or is shared between all users with access to the Application
    # Insights component. Possible values include: 'shared', 'user'
    # @param type [ItemTypeParameter] Enum indicating the type of the Analytics
    # item. Possible values include: 'none', 'query', 'function', 'folder',
    # 'recent'
    # @param include_content [Boolean] Flag indicating whether or not to return the
    # content of each applicable item. If false, only return the item information.
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def list_async(resource_group_name, resource_name, scope_path, scope:nil, type:nil, include_content:nil, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, "'@client.subscription_id' should satisfy the constraint - 'MinLength': '1'" if !@client.subscription_id.nil? && @client.subscription_id.length < 1
      fail ArgumentError, 'resource_group_name is nil' if resource_group_name.nil?
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'MaxLength': '90'" if !resource_group_name.nil? && resource_group_name.length > 90
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'MinLength': '1'" if !resource_group_name.nil? && resource_group_name.length < 1
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'Pattern': '^[-\w\._\(\)]+$'" if !resource_group_name.nil? && resource_group_name.match(Regexp.new('^^[-\w\._\(\)]+$$')).nil?
      fail ArgumentError, 'resource_name is nil' if resource_name.nil?
      fail ArgumentError, 'scope_path is nil' if scope_path.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?
      fail ArgumentError, "'@client.api_version' should satisfy the constraint - 'MinLength': '1'" if !@client.api_version.nil? && @client.api_version.length < 1


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?
      path_template = 'subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/microsoft.insights/components/{resourceName}/{scopePath}'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id,'resourceGroupName' => resource_group_name,'resourceName' => resource_name,'scopePath' => scope_path},
          query_params: {'api-version' => @client.api_version,'scope' => scope,'type' => type,'includeContent' => include_content},
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:get, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRestAzure::AzureOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = {
              client_side_validation: true,
              required: false,
              serialized_name: 'parsed_response',
              type: {
                name: 'Sequence',
                element: {
                    client_side_validation: true,
                    required: false,
                    serialized_name: 'ApplicationInsightsComponentAnalyticsItemElementType',
                    type: {
                      name: 'Composite',
                      class_name: 'ApplicationInsightsComponentAnalyticsItem'
                    }
                }
              }
            }
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Gets a specific Analytics Items defined within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param id [String] The Id of a specific item defined in the Application
    # Insights component
    # @param name [String] The name of a specific item defined in the Application
    # Insights component
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [ApplicationInsightsComponentAnalyticsItem] operation results.
    #
    def get(resource_group_name, resource_name, scope_path, id:nil, name:nil, custom_headers:nil)
      response = get_async(resource_group_name, resource_name, scope_path, id:id, name:name, custom_headers:custom_headers).value!
      response.body unless response.nil?
    end

    #
    # Gets a specific Analytics Items defined within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param id [String] The Id of a specific item defined in the Application
    # Insights component
    # @param name [String] The name of a specific item defined in the Application
    # Insights component
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def get_with_http_info(resource_group_name, resource_name, scope_path, id:nil, name:nil, custom_headers:nil)
      get_async(resource_group_name, resource_name, scope_path, id:id, name:name, custom_headers:custom_headers).value!
    end

    #
    # Gets a specific Analytics Items defined within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param id [String] The Id of a specific item defined in the Application
    # Insights component
    # @param name [String] The name of a specific item defined in the Application
    # Insights component
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def get_async(resource_group_name, resource_name, scope_path, id:nil, name:nil, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, "'@client.subscription_id' should satisfy the constraint - 'MinLength': '1'" if !@client.subscription_id.nil? && @client.subscription_id.length < 1
      fail ArgumentError, 'resource_group_name is nil' if resource_group_name.nil?
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'MaxLength': '90'" if !resource_group_name.nil? && resource_group_name.length > 90
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'MinLength': '1'" if !resource_group_name.nil? && resource_group_name.length < 1
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'Pattern': '^[-\w\._\(\)]+$'" if !resource_group_name.nil? && resource_group_name.match(Regexp.new('^^[-\w\._\(\)]+$$')).nil?
      fail ArgumentError, 'resource_name is nil' if resource_name.nil?
      fail ArgumentError, 'scope_path is nil' if scope_path.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?
      fail ArgumentError, "'@client.api_version' should satisfy the constraint - 'MinLength': '1'" if !@client.api_version.nil? && @client.api_version.length < 1


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?
      path_template = 'subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/microsoft.insights/components/{resourceName}/{scopePath}/item'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id,'resourceGroupName' => resource_group_name,'resourceName' => resource_name,'scopePath' => scope_path},
          query_params: {'api-version' => @client.api_version,'id' => id,'name' => name},
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:get, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRestAzure::AzureOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = Azure::Monitor::Mgmt::V2015_05_01::Models::ApplicationInsightsComponentAnalyticsItem.mapper()
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Adds or Updates a specific Analytics Item within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param item_properties [ApplicationInsightsComponentAnalyticsItem] Properties
    # that need to be specified to create a new item and add it to an Application
    # Insights component.
    # @param override_item [Boolean] Flag indicating whether or not to force save
    # an item. This allows overriding an item if it already exists.
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [ApplicationInsightsComponentAnalyticsItem] operation results.
    #
    def put(resource_group_name, resource_name, scope_path, item_properties, override_item:nil, custom_headers:nil)
      response = put_async(resource_group_name, resource_name, scope_path, item_properties, override_item:override_item, custom_headers:custom_headers).value!
      response.body unless response.nil?
    end

    #
    # Adds or Updates a specific Analytics Item within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param item_properties [ApplicationInsightsComponentAnalyticsItem] Properties
    # that need to be specified to create a new item and add it to an Application
    # Insights component.
    # @param override_item [Boolean] Flag indicating whether or not to force save
    # an item. This allows overriding an item if it already exists.
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def put_with_http_info(resource_group_name, resource_name, scope_path, item_properties, override_item:nil, custom_headers:nil)
      put_async(resource_group_name, resource_name, scope_path, item_properties, override_item:override_item, custom_headers:custom_headers).value!
    end

    #
    # Adds or Updates a specific Analytics Item within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param item_properties [ApplicationInsightsComponentAnalyticsItem] Properties
    # that need to be specified to create a new item and add it to an Application
    # Insights component.
    # @param override_item [Boolean] Flag indicating whether or not to force save
    # an item. This allows overriding an item if it already exists.
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def put_async(resource_group_name, resource_name, scope_path, item_properties, override_item:nil, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, "'@client.subscription_id' should satisfy the constraint - 'MinLength': '1'" if !@client.subscription_id.nil? && @client.subscription_id.length < 1
      fail ArgumentError, 'resource_group_name is nil' if resource_group_name.nil?
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'MaxLength': '90'" if !resource_group_name.nil? && resource_group_name.length > 90
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'MinLength': '1'" if !resource_group_name.nil? && resource_group_name.length < 1
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'Pattern': '^[-\w\._\(\)]+$'" if !resource_group_name.nil? && resource_group_name.match(Regexp.new('^^[-\w\._\(\)]+$$')).nil?
      fail ArgumentError, 'resource_name is nil' if resource_name.nil?
      fail ArgumentError, 'scope_path is nil' if scope_path.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?
      fail ArgumentError, "'@client.api_version' should satisfy the constraint - 'MinLength': '1'" if !@client.api_version.nil? && @client.api_version.length < 1
      fail ArgumentError, 'item_properties is nil' if item_properties.nil?


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?

      # Serialize Request
      request_mapper = Azure::Monitor::Mgmt::V2015_05_01::Models::ApplicationInsightsComponentAnalyticsItem.mapper()
      request_content = @client.serialize(request_mapper,  item_properties)
      request_content = request_content != nil ? JSON.generate(request_content, quirks_mode: true) : nil

      path_template = 'subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/microsoft.insights/components/{resourceName}/{scopePath}/item'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id,'resourceGroupName' => resource_group_name,'resourceName' => resource_name,'scopePath' => scope_path},
          query_params: {'api-version' => @client.api_version,'overrideItem' => override_item},
          body: request_content,
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:put, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRestAzure::AzureOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?
        # Deserialize Response
        if status_code == 200
          begin
            parsed_response = response_content.to_s.empty? ? nil : JSON.load(response_content)
            result_mapper = Azure::Monitor::Mgmt::V2015_05_01::Models::ApplicationInsightsComponentAnalyticsItem.mapper()
            result.body = @client.deserialize(result_mapper, parsed_response)
          rescue Exception => e
            fail MsRest::DeserializationError.new('Error occurred in deserializing the response', e.message, e.backtrace, result)
          end
        end

        result
      end

      promise.execute
    end

    #
    # Deletes a specific Analytics Items defined within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param id [String] The Id of a specific item defined in the Application
    # Insights component
    # @param name [String] The name of a specific item defined in the Application
    # Insights component
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    #
    def delete(resource_group_name, resource_name, scope_path, id:nil, name:nil, custom_headers:nil)
      response = delete_async(resource_group_name, resource_name, scope_path, id:id, name:name, custom_headers:custom_headers).value!
      nil
    end

    #
    # Deletes a specific Analytics Items defined within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param id [String] The Id of a specific item defined in the Application
    # Insights component
    # @param name [String] The name of a specific item defined in the Application
    # Insights component
    # @param custom_headers [Hash{String => String}] A hash of custom headers that
    # will be added to the HTTP request.
    #
    # @return [MsRestAzure::AzureOperationResponse] HTTP response information.
    #
    def delete_with_http_info(resource_group_name, resource_name, scope_path, id:nil, name:nil, custom_headers:nil)
      delete_async(resource_group_name, resource_name, scope_path, id:id, name:name, custom_headers:custom_headers).value!
    end

    #
    # Deletes a specific Analytics Items defined within an Application Insights
    # component.
    #
    # @param resource_group_name [String] The name of the resource group. The name
    # is case insensitive.
    # @param resource_name [String] The name of the Application Insights component
    # resource.
    # @param scope_path [ItemScopePath] Enum indicating if this item definition is
    # owned by a specific user or is shared between all users with access to the
    # Application Insights component. Possible values include: 'analyticsItems',
    # 'myanalyticsItems'
    # @param id [String] The Id of a specific item defined in the Application
    # Insights component
    # @param name [String] The name of a specific item defined in the Application
    # Insights component
    # @param [Hash{String => String}] A hash of custom headers that will be added
    # to the HTTP request.
    #
    # @return [Concurrent::Promise] Promise object which holds the HTTP response.
    #
    def delete_async(resource_group_name, resource_name, scope_path, id:nil, name:nil, custom_headers:nil)
      fail ArgumentError, '@client.subscription_id is nil' if @client.subscription_id.nil?
      fail ArgumentError, "'@client.subscription_id' should satisfy the constraint - 'MinLength': '1'" if !@client.subscription_id.nil? && @client.subscription_id.length < 1
      fail ArgumentError, 'resource_group_name is nil' if resource_group_name.nil?
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'MaxLength': '90'" if !resource_group_name.nil? && resource_group_name.length > 90
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'MinLength': '1'" if !resource_group_name.nil? && resource_group_name.length < 1
      fail ArgumentError, "'resource_group_name' should satisfy the constraint - 'Pattern': '^[-\w\._\(\)]+$'" if !resource_group_name.nil? && resource_group_name.match(Regexp.new('^^[-\w\._\(\)]+$$')).nil?
      fail ArgumentError, 'resource_name is nil' if resource_name.nil?
      fail ArgumentError, 'scope_path is nil' if scope_path.nil?
      fail ArgumentError, '@client.api_version is nil' if @client.api_version.nil?
      fail ArgumentError, "'@client.api_version' should satisfy the constraint - 'MinLength': '1'" if !@client.api_version.nil? && @client.api_version.length < 1


      request_headers = {}
      request_headers['Content-Type'] = 'application/json; charset=utf-8'

      # Set Headers
      request_headers['x-ms-client-request-id'] = SecureRandom.uuid
      request_headers['accept-language'] = @client.accept_language unless @client.accept_language.nil?
      path_template = 'subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/microsoft.insights/components/{resourceName}/{scopePath}/item'

      request_url = @base_url || @client.base_url

      options = {
          middlewares: [[MsRest::RetryPolicyMiddleware, times: 3, retry: 0.02], [:cookie_jar]],
          path_params: {'subscriptionId' => @client.subscription_id,'resourceGroupName' => resource_group_name,'resourceName' => resource_name,'scopePath' => scope_path},
          query_params: {'api-version' => @client.api_version,'id' => id,'name' => name},
          headers: request_headers.merge(custom_headers || {}),
          base_url: request_url
      }
      promise = @client.make_request_async(:delete, path_template, options)

      promise = promise.then do |result|
        http_response = result.response
        status_code = http_response.status
        response_content = http_response.body
        unless status_code == 200
          error_model = JSON.load(response_content)
          fail MsRestAzure::AzureOperationError.new(result.request, http_response, error_model)
        end

        result.request_id = http_response['x-ms-request-id'] unless http_response['x-ms-request-id'].nil?
        result.correlation_request_id = http_response['x-ms-correlation-request-id'] unless http_response['x-ms-correlation-request-id'].nil?
        result.client_request_id = http_response['x-ms-client-request-id'] unless http_response['x-ms-client-request-id'].nil?

        result
      end

      promise.execute
    end

  end
end
