# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Monitor::Mgmt::V2015_05_01
  module Models
    #
    # Properties that define an API key of an Application Insights Component.
    #
    class ApplicationInsightsComponentAPIKey

      include MsRestAzure

      # @return [String] The unique ID of the API key inside an Application
      # Insights component. It is auto generated when the API key is created.
      attr_accessor :id

      # @return [String] The API key value. It will be only return once when
      # the API Key was created.
      attr_accessor :api_key

      # @return [String] The create date of this API key.
      attr_accessor :created_date

      # @return [String] The name of the API key.
      attr_accessor :name

      # @return [Array<String>] The read access rights of this API Key.
      attr_accessor :linked_read_properties

      # @return [Array<String>] The write access rights of this API Key.
      attr_accessor :linked_write_properties


      #
      # Mapper for ApplicationInsightsComponentAPIKey class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplicationInsightsComponentAPIKey',
          type: {
            name: 'Composite',
            class_name: 'ApplicationInsightsComponentAPIKey',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              api_key: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'apiKey',
                type: {
                  name: 'String'
                }
              },
              created_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'createdDate',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              linked_read_properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'linkedReadProperties',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              linked_write_properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'linkedWriteProperties',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
