# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Monitor::Mgmt::V2015_05_01
  module Models
    #
    # An Application Insights component Continuous Export configuration request
    # definition.
    #
    class ApplicationInsightsComponentExportRequest

      include MsRestAzure

      # @return [String] The document types to be exported, as comma separated
      # values. Allowed values include 'Requests', 'Event', 'Exceptions',
      # 'Metrics', 'PageViews', 'PageViewPerformance', 'Rdd',
      # 'PerformanceCounters', 'Availability', 'Messages'.
      attr_accessor :record_types

      # @return [String] The Continuous Export destination type. This has to be
      # 'Blob'.
      attr_accessor :destination_type

      # @return [String] The SAS URL for the destination storage container. It
      # must grant write permission.
      attr_accessor :destination_address

      # @return [String] Set to 'true' to create a Continuous Export
      # configuration as enabled, otherwise set it to 'false'.
      attr_accessor :is_enabled

      # @return [String] Deprecated
      attr_accessor :notification_queue_enabled

      # @return [String] Deprecated
      attr_accessor :notification_queue_uri

      # @return [String] The subscription ID of the destination storage
      # container.
      attr_accessor :destination_storage_subscription_id

      # @return [String] The location ID of the destination storage container.
      attr_accessor :destination_storage_location_id

      # @return [String] The name of destination storage account.
      attr_accessor :destination_account_id


      #
      # Mapper for ApplicationInsightsComponentExportRequest class as Ruby
      # Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplicationInsightsComponentExportRequest',
          type: {
            name: 'Composite',
            class_name: 'ApplicationInsightsComponentExportRequest',
            model_properties: {
              record_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'RecordTypes',
                type: {
                  name: 'String'
                }
              },
              destination_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DestinationType',
                type: {
                  name: 'String'
                }
              },
              destination_address: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DestinationAddress',
                type: {
                  name: 'String'
                }
              },
              is_enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'IsEnabled',
                type: {
                  name: 'String'
                }
              },
              notification_queue_enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'NotificationQueueEnabled',
                type: {
                  name: 'String'
                }
              },
              notification_queue_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'NotificationQueueUri',
                type: {
                  name: 'String'
                }
              },
              destination_storage_subscription_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DestinationStorageSubscriptionId',
                type: {
                  name: 'String'
                }
              },
              destination_storage_location_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DestinationStorageLocationId',
                type: {
                  name: 'String'
                }
              },
              destination_account_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DestinationAccountId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
