# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Monitor::Mgmt::V2015_05_01
  module Models
    #
    # An Application Insights component daily data volume cap status
    #
    class ApplicationInsightsComponentFeature

      include MsRestAzure

      # @return [String] The pricing feature name.
      attr_accessor :feature_name

      # @return [String] The meter id used for the feature.
      attr_accessor :meter_id

      # @return [String] The meter rate for the feature's meter.
      attr_accessor :meter_rate_frequency

      # @return [String] Reserved, not used now.
      attr_accessor :resouce_id

      # @return [Boolean] Reserved, not used now.
      attr_accessor :is_hidden

      # @return [Array<ApplicationInsightsComponentFeatureCapability>] A list
      # of Application Insights component feature capability.
      attr_accessor :capabilities

      # @return [String] Display name of the feature.
      attr_accessor :title

      # @return [Boolean] Whether can apply addon feature on to it.
      attr_accessor :is_main_feature

      # @return [String] The add on features on main feature.
      attr_accessor :supported_addon_features


      #
      # Mapper for ApplicationInsightsComponentFeature class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplicationInsightsComponentFeature',
          type: {
            name: 'Composite',
            class_name: 'ApplicationInsightsComponentFeature',
            model_properties: {
              feature_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'FeatureName',
                type: {
                  name: 'String'
                }
              },
              meter_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'MeterId',
                type: {
                  name: 'String'
                }
              },
              meter_rate_frequency: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'MeterRateFrequency',
                type: {
                  name: 'String'
                }
              },
              resouce_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'ResouceId',
                type: {
                  name: 'String'
                }
              },
              is_hidden: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'IsHidden',
                type: {
                  name: 'Boolean'
                }
              },
              capabilities: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'Capabilities',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ApplicationInsightsComponentFeatureCapabilityElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ApplicationInsightsComponentFeatureCapability'
                      }
                  }
                }
              },
              title: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'Title',
                type: {
                  name: 'String'
                }
              },
              is_main_feature: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'IsMainFeature',
                type: {
                  name: 'Boolean'
                }
              },
              supported_addon_features: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'SupportedAddonFeatures',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
