# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Monitor::Mgmt::V2016_03_01
  module Models
    #
    # A rule management event data source. The discriminator fields is always
    # RuleManagementEventDataSource in this case.
    #
    class RuleManagementEventDataSource < RuleDataSource

      include MsRestAzure


      def initialize
        @odatatype = "Microsoft.Azure.Management.Insights.Models.RuleManagementEventDataSource"
      end

      attr_accessor :odatatype

      # @return [String] the event name.
      attr_accessor :event_name

      # @return [String] the event source.
      attr_accessor :event_source

      # @return [String] the level.
      attr_accessor :level

      # @return [String] The name of the operation that should be checked for.
      # If no name is provided, any operation will match.
      attr_accessor :operation_name

      # @return [String] the resource group name.
      attr_accessor :resource_group_name

      # @return [String] the resource provider name.
      attr_accessor :resource_provider_name

      # @return [String] The status of the operation that should be checked
      # for. If no status is provided, any status will match.
      attr_accessor :status

      # @return [String] the substatus.
      attr_accessor :sub_status

      # @return [RuleManagementEventClaimsDataSource] the claims.
      attr_accessor :claims


      #
      # Mapper for RuleManagementEventDataSource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Microsoft.Azure.Management.Insights.Models.RuleManagementEventDataSource',
          type: {
            name: 'Composite',
            class_name: 'RuleManagementEventDataSource',
            model_properties: {
              resource_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceUri',
                type: {
                  name: 'String'
                }
              },
              odatatype: {
                client_side_validation: true,
                required: true,
                serialized_name: 'odata\\.type',
                type: {
                  name: 'String'
                }
              },
              event_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'eventName',
                type: {
                  name: 'String'
                }
              },
              event_source: {
                client_side_validation: true,
                required: false,
                serialized_name: 'eventSource',
                type: {
                  name: 'String'
                }
              },
              level: {
                client_side_validation: true,
                required: false,
                serialized_name: 'level',
                type: {
                  name: 'String'
                }
              },
              operation_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'operationName',
                type: {
                  name: 'String'
                }
              },
              resource_group_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceGroupName',
                type: {
                  name: 'String'
                }
              },
              resource_provider_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceProviderName',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              sub_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'subStatus',
                type: {
                  name: 'String'
                }
              },
              claims: {
                client_side_validation: true,
                required: false,
                serialized_name: 'claims',
                type: {
                  name: 'Composite',
                  class_name: 'RuleManagementEventClaimsDataSource'
                }
              }
            }
          }
        }
      end
    end
  end
end
