# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Monitor::Mgmt::V2018_03_01
  module Models
    #
    # Criterion for dynamic threshold.
    #
    class DynamicMetricCriteria < MultiMetricCriteria

      include MsRestAzure


      def initialize
        @criterionType = "DynamicThresholdCriterion"
      end

      attr_accessor :criterionType

      # @return [DynamicThresholdOperator] The operator used to compare the
      # metric value against the threshold. Possible values include:
      # 'GreaterThan', 'LessThan', 'GreaterOrLessThan'
      attr_accessor :operator

      # @return [DynamicThresholdSensitivity] The extent of deviation required
      # to trigger an alert. This will affect how tight the threshold is to the
      # metric series pattern. Possible values include: 'Low', 'Medium', 'High'
      attr_accessor :alert_sensitivity

      # @return [DynamicThresholdFailingPeriods] The minimum number of
      # violations required within the selected lookback time window required
      # to raise an alert.
      attr_accessor :failing_periods

      # @return [DateTime] Use this option to set the date from which to start
      # learning the metric historical data and calculate the dynamic
      # thresholds (in ISO8601 format)
      attr_accessor :ignore_data_before


      #
      # Mapper for DynamicMetricCriteria class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DynamicThresholdCriterion',
          type: {
            name: 'Composite',
            class_name: 'DynamicMetricCriteria',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              metric_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'metricName',
                type: {
                  name: 'String'
                }
              },
              metric_namespace: {
                client_side_validation: true,
                required: false,
                serialized_name: 'metricNamespace',
                type: {
                  name: 'String'
                }
              },
              time_aggregation: {
                client_side_validation: true,
                required: true,
                serialized_name: 'timeAggregation',
                type: {
                  name: 'Object'
                }
              },
              dimensions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dimensions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'MetricDimensionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'MetricDimension'
                      }
                  }
                }
              },
              skip_metric_validation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'skipMetricValidation',
                type: {
                  name: 'Boolean'
                }
              },
              criterionType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'criterionType',
                type: {
                  name: 'String'
                }
              },
              operator: {
                client_side_validation: true,
                required: true,
                serialized_name: 'operator',
                type: {
                  name: 'String'
                }
              },
              alert_sensitivity: {
                client_side_validation: true,
                required: true,
                serialized_name: 'alertSensitivity',
                type: {
                  name: 'String'
                }
              },
              failing_periods: {
                client_side_validation: true,
                required: true,
                serialized_name: 'failingPeriods',
                type: {
                  name: 'Composite',
                  class_name: 'DynamicThresholdFailingPeriods'
                }
              },
              ignore_data_before: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ignoreDataBefore',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
