# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Monitor::Mgmt::V2018_09_01
  module Models
    #
    # The response to a baseline query.
    #
    class BaselineResponse

      include MsRestAzure

      # @return [String] The metric baseline ID.
      attr_accessor :id

      # @return [String] The resource type of the baseline resource.
      attr_accessor :type

      # @return [LocalizableString] The name and the display name of the
      # metric, i.e. it is localizable string.
      attr_accessor :name

      # @return [String] The timespan for which the data was retrieved. Its
      # value consists of two datetimes concatenated, separated by '/'.  This
      # may be adjusted in the future and returned back from what was
      # originally requested.
      attr_accessor :timespan

      # @return [Duration] The interval (window size) for which the metric data
      # was returned in.  This may be adjusted in the future and returned back
      # from what was originally requested.  This is not present if a metadata
      # request was made.
      attr_accessor :interval

      # @return [String] The aggregation type of the metric.
      attr_accessor :aggregation

      # @return [Array<DateTime>] The array of timestamps of the baselines.
      attr_accessor :timestamps

      # @return [Array<Baseline>] The baseline values for each sensitivity.
      attr_accessor :baseline

      # @return [Array<BaselineMetadataValue>] The baseline metadata values.
      attr_accessor :metadata


      #
      # Mapper for BaselineResponse class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BaselineResponse',
          type: {
            name: 'Composite',
            class_name: 'BaselineResponse',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'Composite',
                  class_name: 'LocalizableString'
                }
              },
              timespan: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.timespan',
                type: {
                  name: 'String'
                }
              },
              interval: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.interval',
                type: {
                  name: 'TimeSpan'
                }
              },
              aggregation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.aggregation',
                type: {
                  name: 'String'
                }
              },
              timestamps: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.timestamps',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DateTimeElementType',
                      type: {
                        name: 'DateTime'
                      }
                  }
                }
              },
              baseline: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.baseline',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'BaselineElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Baseline'
                      }
                  }
                }
              },
              metadata: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.metadata',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'BaselineMetadataValueElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'BaselineMetadataValue'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
