# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Monitor::Mgmt::V2019_03_01
  module Models
    #
    # The baseline values for a single time series.
    #
    class TimeSeriesBaseline

      include MsRestAzure

      # @return [String] The aggregation type of the metric.
      attr_accessor :aggregation

      # @return [Array<MetricSingleDimension>] The dimensions of this time
      # series.
      attr_accessor :dimensions

      # @return [Array<DateTime>] The list of timestamps of the baselines.
      attr_accessor :timestamps

      # @return [Array<SingleBaseline>] The baseline values for each
      # sensitivity.
      attr_accessor :data

      # @return [Array<BaselineMetadata>] The baseline metadata values.
      attr_accessor :metadata


      #
      # Mapper for TimeSeriesBaseline class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'TimeSeriesBaseline',
          type: {
            name: 'Composite',
            class_name: 'TimeSeriesBaseline',
            model_properties: {
              aggregation: {
                client_side_validation: true,
                required: true,
                serialized_name: 'aggregation',
                type: {
                  name: 'String'
                }
              },
              dimensions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dimensions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'MetricSingleDimensionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'MetricSingleDimension'
                      }
                  }
                }
              },
              timestamps: {
                client_side_validation: true,
                required: true,
                serialized_name: 'timestamps',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DateTimeElementType',
                      type: {
                        name: 'DateTime'
                      }
                  }
                }
              },
              data: {
                client_side_validation: true,
                required: true,
                serialized_name: 'data',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'SingleBaselineElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'SingleBaseline'
                      }
                  }
                }
              },
              metadata: {
                client_side_validation: true,
                required: false,
                serialized_name: 'metadata',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'BaselineMetadataElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'BaselineMetadata'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
