# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Network::Mgmt::V2016_06_01
  module Models
    #
    # Effective NetworkSecurityRules
    #
    class EffectiveNetworkSecurityRule

      include MsRestAzure

      # @return [String] Gets the name of the security rule specified by the
      # user (if created by the user)
      attr_accessor :name

      # @return [SecurityRuleProtocol] Gets Network protocol this rule applies
      # to. Possible values include: 'Tcp', 'Udp', '*'
      attr_accessor :protocol

      # @return [String] Gets source port or range
      attr_accessor :source_port_range

      # @return [String] Gets destination port or range
      attr_accessor :destination_port_range

      # @return [String] Gets source address prefix
      attr_accessor :source_address_prefix

      # @return [String] Gets destination address prefix
      attr_accessor :destination_address_prefix

      # @return [Array<String>] Gets expanded source address prefix
      attr_accessor :expanded_source_address_prefix

      # @return [Array<String>] Gets expanded destination address prefix
      attr_accessor :expanded_destination_address_prefix

      # @return [SecurityRuleAccess] Gets network traffic is allowed or denied.
      # Possible values include: 'Allow', 'Deny'
      attr_accessor :access

      # @return [Integer] Gets the priority of the rule
      attr_accessor :priority

      # @return [SecurityRuleDirection] Gets the direction of the rule.
      # Possible values include: 'Inbound', 'Outbound'
      attr_accessor :direction


      #
      # Mapper for EffectiveNetworkSecurityRule class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EffectiveNetworkSecurityRule',
          type: {
            name: 'Composite',
            class_name: 'EffectiveNetworkSecurityRule',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              protocol: {
                client_side_validation: true,
                required: false,
                serialized_name: 'protocol',
                type: {
                  name: 'String'
                }
              },
              source_port_range: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourcePortRange',
                type: {
                  name: 'String'
                }
              },
              destination_port_range: {
                client_side_validation: true,
                required: false,
                serialized_name: 'destinationPortRange',
                type: {
                  name: 'String'
                }
              },
              source_address_prefix: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceAddressPrefix',
                type: {
                  name: 'String'
                }
              },
              destination_address_prefix: {
                client_side_validation: true,
                required: false,
                serialized_name: 'destinationAddressPrefix',
                type: {
                  name: 'String'
                }
              },
              expanded_source_address_prefix: {
                client_side_validation: true,
                required: false,
                serialized_name: 'expandedSourceAddressPrefix',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              expanded_destination_address_prefix: {
                client_side_validation: true,
                required: false,
                serialized_name: 'expandedDestinationAddressPrefix',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              access: {
                client_side_validation: true,
                required: false,
                serialized_name: 'access',
                type: {
                  name: 'String'
                }
              },
              priority: {
                client_side_validation: true,
                required: false,
                serialized_name: 'priority',
                type: {
                  name: 'Number'
                }
              },
              direction: {
                client_side_validation: true,
                required: false,
                serialized_name: 'direction',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
