# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Network::Mgmt::V2018_08_01
  module Models
    #
    # Tap configuration in a Network Interface
    #
    class NetworkInterfaceTapConfiguration < SubResource

      include MsRestAzure

      # @return [VirtualNetworkTap] The reference of the Virtual Network Tap
      # resource.
      attr_accessor :virtual_network_tap

      # @return [String] The provisioning state of the network interface tap
      # configuration. Possible values are: 'Updating', 'Deleting', and
      # 'Failed'.
      attr_accessor :provisioning_state

      # @return [String] The name of the resource that is unique within a
      # resource group. This name can be used to access the resource.
      attr_accessor :name

      # @return [String] A unique read-only string that changes whenever the
      # resource is updated.
      attr_accessor :etag

      # @return [String] Sub Resource type.
      attr_accessor :type


      #
      # Mapper for NetworkInterfaceTapConfiguration class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'NetworkInterfaceTapConfiguration',
          type: {
            name: 'Composite',
            class_name: 'NetworkInterfaceTapConfiguration',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              virtual_network_tap: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.virtualNetworkTap',
                type: {
                  name: 'Composite',
                  class_name: 'VirtualNetworkTap'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
